/*
File: MessageQueue.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/

package webwisdom.tango.structures;


import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.messages.EmptyMessage;


public class MessageQueue extends Vector {



  public MessageQueue() {
    super();
  }

  

  public synchronized void putMessage(Message m) {

    this.addElement(m);
    notify();
  }


  public synchronized Message getMessage() {
 
    Message result;

    if (this.isEmpty()) 
      try {
	wait();
      } catch(Exception e) {

	System.out.println("MessageQueue: " + e);
					e.printStackTrace();

      }

    result = (Message) this.firstElement();

    this.removeElementAt(0);


    return result;
    

  }


  public synchronized void unblock() {
    
    EmptyMessage empty = new EmptyMessage();
    this.addElement(empty);
    notify();

  }
	
  public synchronized boolean empty() {

    return this.isEmpty();
  }


  public synchronized void clear() {
  
    this.removeAllElements();

  }

}





